<template>
  <div>
    <label class="block">{{label}}</label>
    <div class="preview">
      <div v-for="(img, index) in files" :key="index" class="preview-img">
        <img :src="img" />
        <q-btn class="preview-delete" dense color="negative" icon="close" @click="onDelete(index)" />
      </div>
    </div>
    <div class="row q-mt-md" v-if="max === -1 || value.length < max">
      <div class="uploader-btn">
        <q-btn no-caps color="secondary" icon="cloud_upload" label="Đăng" />
        <input
          id="uploader"
          ref="uploader"
          type="file"
          @change="onUpload"
          accept="image/gif, image/jpg, image/jpeg, image/png"
        />
      </div>
    </div>
  </div>
</template>

<script>
import { FileUtils } from '~/utils';

export default {
  props: {
    label: { type: String, default: '' },
    value: { type: Array, default: () => [] },
    multiple: { type: Boolean, default: true },
    max: { type: Number, default: -1 }
  },
  data() {
    return {
      files: []
    };
  },
  watch: {
    value: {
      handler() {
        this.files = [...this.value];
      },
      immediate: true
    }
  },
  methods: {
    onDelete(index) {
      this.files = this.files.filter((_, idx) => idx !== index);
      this.$emit('input', this.files);
    },
    onUpload() {
      const { uploader } = this.$refs;
      if (uploader) {
        FileUtils.convertFileToBase64(uploader.files[0]).then(base64 => {
          if (this.multiple) {
            this.files.push(base64);
          } else {
            this.files = [base64];
          }
          this.$emit('input', this.files);
        });
      }
    }
  }
};
</script>

<style lang="scss" scoped>
.preview {
  display: flex;
  flex-direction: row;
  align-items: center;

  .preview-img {
    position: relative;
    width: 180px;
    margin: 10px 0;
    margin-right: 10px;

    .preview-delete {
      position: absolute;
      right: 10px;
      top: 10px;
    }
    img {
      width: 100%;
    }
  }
}

.uploader-btn {
  position: relative;
  overflow: hidden;
  display: inline-block;

  input[type='file'] {
    font-size: 100px;
    position: absolute;
    left: 0;
    top: 0;
    opacity: 0;
  }
}
</style>
